 PROGRAM Intro;
 { Glen H. Barratt
   Itroduction to TEXAS Road Rampage}
 USES
  Crt,Graph,Dos,PalUnit;

 CONST
  Red=45;
  Orange=60;
  Yellow=75;
  Green=90;
  Blue=105;
  Purple=120;
  White=150;

 TYPE
  ByteFile=File of Byte;
  TArray=Array[1..2] of Pointer;
  IntFile=File of Integer;
  PalArray=Array[0..255,1..3] of Integer;

 VAR
  Pal:PalArray;
  T:TArray;
  PicFile:IntFile;
  BFile:ByteFile;
  GraphDriver,GraphMode,ErrorCode:Integer;
  OldExitProc:Pointer;
  X,R,i,i2,i3,i4,i5,i6:Integer;
  Sounds:Boolean;
  Key:Char;

 Function I2S(L:LongInt):String;
  {Converts an integer to a string for use with OutText, OutTextXY }
 Var
  S:String;
 Begin
  Str(L, S);
  I2S:= S;
 End; { I2S }

 {$F+}
 Procedure MyExitProc;
 Begin
   ExitProc:=OldExitProc; { Restore exit procedure address }
   CloseGraph;              { Shut down the graphics system }
 End; { MyExitProc }
 {$F-}

 Procedure SetPal(c,r,g,b:byte); assembler; asm
  mov dx,3c8h; mov al,[c]; out dx,al; inc dx; mov al,[r]
  out dx,al; mov al,[g]; out dx,al; mov al,[b]; out dx,al; end;

 {$F+}
 Function DetectVGA256 : integer;
  {Detects VGA or MCGA video cards }
 Var
   DetectedDriver,SuggestedMode:Integer;
 Begin
   DetectGraph(DetectedDriver, SuggestedMode);
   If (DetectedDriver = VGA) or (DetectedDriver = MCGA) then DetectVGA256:= 0
   Else DetectVGA256 := grError; { Couldn't detect hardware }
 End; { DetectVGA256 }
 {$F-}

 VAR
  AutoDetectPointer:Pointer;

 Procedure Initialize;
  {Initialize graphics and report any errors that may occur }
 Var
  InGraphicsMode:Boolean; { Flags initialization of graphics mode }
  PathToDriver:String;  { Stores the DOS path to *.BGI & *.CHR }
 Begin
  { when using Crt and graphics, turn off Crt's memory-mapped writes }
  DirectVideo:=False;
  OldExitProc:=ExitProc;                { save previous exit proc }
  ExitProc:= @MyExitProc;                { insert our exit proc in chain }
  PathToDriver:='';
  Repeat
   AutoDetectPointer:= @DetectVGA256;   { Point to detection routine }
   GraphDriver:= InstallUserDriver('VGA256', AutoDetectPointer);
   GraphDriver:= Detect;
   InitGraph(GraphDriver, GraphMode, PathToDriver);
   ErrorCode:= GraphResult;             { preserve error return }
   If ErrorCode <> grOK then begin            { error? }
    Writeln('Graphics error: ', GraphErrorMsg(ErrorCode));
    If ErrorCode=grFileNotFound then begin{ Can't find driver file }
     Writeln('Enter full path to BGI driver or type <Ctrl-Break> to quit:');
     Readln(PathToDriver);
     Writeln;
    End
    Else
    Halt(1);                          { Some other error: terminate }
   End;
  Until ErrorCode=grOK;
  Randomize;                { init random number generator }
 End; { Initialize }

 Procedure GetDriverAndMode(VAR DriveStr, ModeStr:String);
  {Return strings describing the current device driver and graphics mode
  for display of status report }
 Begin
  DriveStr:= GetDriverName;
  ModeStr:= GetModeName(GetGraphMode);
 End; { GetDriverAndMode }

 Procedure LoadPalette(FileName:String);
 Var
  i:Integer;
  R,G,B:Byte;
 Begin
  Assign(BFile,FileName);
  Reset(BFile);
  For i:= 0 to 255 do begin
   R:=63;
   G:=63;
   B:=63;
   Read(BFile,R);
   Read(BFile,G);
   Read(BFile,B);
   MakeColor(i,R,G,B);
  End;
  Close(BFile);
 End;

 Procedure Fadeto(FileName:String;Steps:Integer);
 Var
  i,i2:Integer;
  R,G,B:Byte;
  Pal:Array[0..255,1..3] of Real;
  Pal2:Array[0..255,1..3] of Real;
  CStep:Array[0..255,1..3] of Real;
 Begin
  For i:= 0 to 255 do begin
   GetColor(i,R,G,B);
   Pal[i,1]:=R;
   Pal[i,2]:=G;
   Pal[i,3]:=B;
  End;
  Assign(BFile,FileName);
  Reset(BFile);
  For i:= 0 to 255 do begin
   Read(BFile,R);
   Read(BFile,G);
   Read(BFile,B);
   Pal2[i,1]:=R;
   Pal2[i,2]:=G;
   Pal2[i,3]:=B;
  End;
  Close(BFile);

  For i:= 0 to 255 do begin
   CStep[i,1]:=((Pal2[i,1]-Pal[i,1])/Steps);
   CStep[i,2]:=((Pal2[i,2]-Pal[i,2])/Steps);
   CStep[i,3]:=((Pal2[i,3]-Pal[i,3])/Steps);
  End;

  For i2:= 0 to Steps do begin
   For i:= 0 to 255 do begin
    Pal[i,1]:=Pal[i,1]+CStep[i,1];
    Pal[i,2]:=Pal[i,2]+CStep[i,2];
    Pal[i,3]:=Pal[i,3]+CStep[i,3];
    MakeColor(i,Round(Pal[i,1]),Round(Pal[i,2]),Round(Pal[i,3]));
   End;
   Delay(10);
  End;
  LoadPalette(FileName);
 End;

 Procedure FadetoBlack(Steps:Integer);
 Var
  i,i2:Integer;
  R,G,B:Byte;
  Pal:Array[0..255,1..3] of Real;
  Pal2:Array[0..255,1..3] of Real;
  CStep:Array[0..255,1..3] of Real;
 Begin
  For i:= 0 to 255 do begin
   GetColor(i,R,G,B);
   Pal[i,1]:=R;
   Pal[i,2]:=G;
   Pal[i,3]:=B;
  End;
  For i:= 0 to 255 do begin
   Pal2[i,1]:=0;
   Pal2[i,2]:=0;
   Pal2[i,3]:=0;
  End;

  For i:= 0 to 255 do begin
   CStep[i,1]:=((Pal2[i,1]-Pal[i,1])/Steps);
   CStep[i,2]:=((Pal2[i,2]-Pal[i,2])/Steps);
   CStep[i,3]:=((Pal2[i,3]-Pal[i,3])/Steps);
  End;

  For i2:= 1 to Steps do begin
   For i:= 0 to 255 do begin
    Pal[i,1]:=Pal[i,1]+CStep[i,1];
    Pal[i,2]:=Pal[i,2]+CStep[i,2];
    Pal[i,3]:=Pal[i,3]+CStep[i,3];
    MakeColor(i,Round(Pal[i,1]),Round(Pal[i,2]),Round(Pal[i,3]));
   End;
   Delay(10);
  End;
  For i:= 0 to 255 do begin
   MakeColor(i,0,0,0);
  End;
 End;


 Procedure CopyTiles(CLTiles:Integer);
 Var
  CurPort:ViewPortType;
  X,Y:Integer;
  Size:Word;
  FileName:String;
  PX1,PX2,PY1,PY2,o,i,i2,i3,i4,Mi:Integer;
 Begin
  ClearDevice;
  GetViewSettings(CurPort);
  FileName:='Road.dpc';
  Assign(PicFile,FileName);
  Reset(PicFile);
  o:= 0;
  PX1:=1;
  PY1:=1;
  Read(PicFile,X);
  PX2:= PX1+X;
  Read(PicFile,Y);
  PY2:= PY1+Y;
  For i4:= PY1 to PY2 do
  For i2:= PX1 to PX2 do begin
   Read(PicFile,o);
   If o=0 then o:=1
   Else PutPixel(i2,i4,o);
  End;
  Close(PicFile);
  Size:=ImageSize(PX1,PY1,PX2,PY2);
  GetMem(T[1],Size);
  GetImage(PX1,PY1,PX2,PY2,T[1]^);

  ClearDevice;
  GetViewSettings(CurPort);
  FileName:='Rampage.dpc';
  Assign(PicFile,FileName);
  Reset(PicFile);
  o:= 0;
  PX1:=1;
  PY1:=1;
  Read(PicFile,X);
  PX2:= PX1+X;
  Read(PicFile,Y);
  PY2:= PY1+Y;
  For i4:= PY1 to PY2 do
  For i2:= PX1 to PX2 do begin
   Read(PicFile,o);
   If o=0 then o:=1
   Else PutPixel(i2,i4,o);
  End;
  Close(PicFile);
  Size:=ImageSize(PX1,PY1,PX2,PY2);
  GetMem(T[2],Size);
  GetImage(PX1,PY1,PX2,PY2,T[2]^);
 End;

 Procedure Load(X,Y:Integer;FileName:String);
 Var PX1,PX2,PY1,PY2,i,i2,i3,i4,o:Integer;
 Begin
  Assign(PicFile,FileName);
  Reset(PicFile);
  o:= 0;
  PX1:=X;
  PY1:=Y;
  Read(PicFile,X);
  PX2:= PX1+X;
  Read(PicFile,Y);
  PY2:= PY1+Y;
  For i4:= PY1 to PY2 do
  For i2:= PX1 to PX2 do begin
   Read(PicFile,o);
   If o=0 then o:=1
   Else PutPixel(i2,i4,o);
  End;
  Close(PicFile);
 End;

 Procedure Main;
 Var i,i2,i3:Integer;
 Begin
  ClearDevice;
  Load(105,50,'TEXAS.dpc');
  Fadeto('Game.pal',200);
  If Sounds then begin
   For i:= 900 downto 1 do begin
    Sound(200+Round(i/10)+Random(25));
    Delay(1)
   End;
   For i:= 1 to 2000 do begin
    Sound(200+Round(i/10)+Random(25));
    Delay(1)
   End;
   NoSound;
  End;
  Delay(100);
  For i:= -200 to 0 do begin
   PutImage(65+i,65,T[1]^,XOrPut);
   PutImage(140+i,65,T[2]^,XOrPut);
   If Sounds then Sound(800+i+Random(200-i));
   Delay(2);
   PutImage(65+i,65,T[1]^,XOrPut);
   PutImage(140+i,65,T[2]^,XOrPut);
  End;
  NoSound;
  ClearDevice;
  Load(105,50,'TEXAS.dpc');
  Load(65,65,'Road.dpc');
  Load(140,65,'Rampage.dpc');
  Repeat
   If Keypressed then Key:=ReadKey;
  Until (Key=chr(13))or(key=chr(27))or(key=' ');
 End;

 Procedure Claimer;
 Begin
  Load(110,60,'Claimer.dpc');
  Delay(2000);
 End;

 Procedure Buckleup;
 Begin
  SetColor(White);
  OuttextXY(100,50,'BUCKLE UP...');
  Load(100,50,'Buckleup.dpc');
  SetColor(White);
  OuttextXY(100,100,'ITS THE LAW.');
  Delay(2000);
 End;

 BEGIN
  Initialize;
  Asm mov ax,13h; int 10h; end;
  LoadPalette('game.pal');
  ClearDevice;

  Sounds:=True;
  CopyTiles(2);
  ClearDevice;
  Claimer;
  FadetoBlack(200);
  ClearDevice;
  BuckleUp;
  Fadeto('Game.pal',200);
  FadetoBlack(200);
  ClearDevice;
  Main;

 END.

