 {$G+}
 PROGRAM RoadRampage;
  {
   Programmer: Glen H. Barratt
   Started: May 23, 1997
   Completed:
  }

 USES
  Crt,PlayHSC,Dos,PalUnit;

 LABEL
  ReLevel;

 CONST
  vidseg:word=$a000;
  MaxRTypes=4;                                               { Defines Floor Tiles and Wall's Array Size }
  MaxCTypes=5;
  MaxCars=100;
  MaxBTypes=5;
  MaxBullets=100;
  MaxPlayers=(2*5);

  Red=45;
  Orange=60;
  Yellow=75;
  Green=90;
  Blue=105;
  Purple=120;
  White=150;

  OXSize=21;
  OYSize=26;
  RXSize=101;
  RYSize=10;

  MaxRoadSize=3000;

 TYPE
  ByteFile=File of Byte;
  TSprRec=Record sprseg:word; buf:pointer; End;
  CSprRec=Record sprseg:word; buf:pointer; End;
  PSprRec=Record sprseg:word; buf:pointer; End;
  BSprRec=Record sprseg:word; buf:pointer; End;
  CarRecord=Record
   Col:Integer;
   Row:LongInt;
   CLife:Integer;
   Kin:ShortInt;
   Attack:ShortInt;
   Speed:Integer;
  End;

  BPosArray=Array[1..MaxBullets,1..2] of Integer;
  CarArray=Array[1..MaxCars] of CarRecord;
  RoadMapArray=Array[1..MaxRoadSize] of ShortInt;
  IntFile=File of Integer;

 VAR
  R:Array[-4..MaxRTypes] of TSprRec;                { Spaces made in memory for the BackgroundTiles (using PutImage) }
  C:Array[1..MaxCars] of CSprRec;                 { Spaces made in memory for the BackgroundTiles (using PutImage) }
  P:Array[1..MaxPlayers] of PSprRec;              { Spaces made in memory for the BackgroundTiles (using PutImage) }
  B:Array[1..MaxBTypes] of BSprRec;               { Spaces made in memory for the BackgroundTiles (using PutImage) }
  virseg,bgseg,fseg,fofs:word;
  heap,virscr,bgscr:pointer;
  BPos:BPosArray;
  PicFile:IntFile;
  RoadMap:RoadMapArray;
  Car:CarArray;
  TextFile:Text;
  BFile:ByteFile;
  GraphDriver,GraphMode,ErrorCode:Integer;
  OldExitProc:Pointer;
  X,i,i2,i3,i4,i5,i6:Integer;
  PCol,PRow:Integer;
  CarPrice,Score,Life,Speed,Gas,RoadPos,FinishRow:LongInt;
  MaxLife,MAxSpeed,MaxGas,Strength:LongInt;
  BulletAttack,CS,GASTanks,Weapon,Tanks,RKS,CarType,CLTiles:Integer;
  Sounds:Boolean;
  Key:Char;
  RefreshStats,goodbye:Boolean;
  WeaponFileName,BlastFileName,BFileName,CarFileName:String;
  BSpeed,Bullets,CBullet,Level,GasGuzzle,Tracker:Integer;
  CarCondition,BType:ShortInt;

  Music:HSC_obj;

 {$F+}
 {$L MUSIC.OBJ}
 PROCEDURE MUSIC_DATA; EXTERNAL;
 {$F-}

 Procedure Getfont; assembler; asm
  mov ax,1130h; mov bh,1; int 10h; mov fseg,es; mov fofs,bp; end;

 Procedure Flip(src,dst,offs:word); assembler; asm
  push ds; mov ds,[src]; mov si,[offs]; mov es,[dst]
  xor di,di; mov cx,320*200/2; rep movsw; pop ds; end;

 Procedure CLS(dst:word); assembler; asm
  mov es,[dst]; xor di,di; xor ax,ax; mov cx,320*200/2; rep stosw; end;

 Procedure Retrace; assembler; asm
  mov dx,03dah; @vert1: in al,dx; test al,8; jnz @vert1
  @vert2: in al,dx; test al,8; jz @vert2; end;


 Procedure PutRoad(x,y,sprseg,virseg:word); assembler;
 Asm
  push ds
  mov ds,sprseg; xor si,si { get sprite segment }
  mov es,virseg; xor di,di { get virtial screen segment }
  mov ax,[y]; shl ax,6; mov di,ax; shl ax,2; add di,ax { y*320 }
  add di,[x] { y*320+x }
  mov dx,320-rxsize { number of pixels left on line }
  mov bx,rysize
 @l1:
  mov cx,rxsize
 @l0:
  lodsb; or al,al; jz @skip { get byte from sprite and check if black }
  mov [es:di],al { draw it }
 @skip:
  inc di; dec cx; jnz @l0
  add di,dx; dec bx; jnz @l1
  pop ds
 End;

 Procedure PutObject(x,y,sprseg,virseg:word); assembler;
 Asm
  push ds
  mov ds,sprseg; xor si,si { get sprite segment }
  mov es,virseg; xor di,di { get virtial screen segment }
  mov ax,[y]; shl ax,6; mov di,ax; shl ax,2; add di,ax { y*320 }
  add di,[x] { y*320+x }
  mov dx,320-oxsize { number of pixels left on line }
  mov bx,oysize
 @l1:
  mov cx,oxsize
 @l0:
  lodsb; or al,al; jz @skip { get byte from sprite and check if black }
  mov [es:di],al { draw it }
 @skip:
  inc di; dec cx; jnz @l0
  add di,dx; dec bx; jnz @l1
  pop ds
 End;

 Procedure PutPixel(x,y:word; c:byte; lvseg:word); assembler; asm
  mov es,[lvseg]; mov ax,[y]; shl ax,6; mov di,ax; shl ax,2
  add di,ax; add di,[x]; mov al,[c]; mov [es:di],al; end;

 Procedure Line(X1,Y1,X2,Y2,C,Place:Word);
 Var X,Y:Integer;
 Begin
  For X:= X1 to X2 do
  For Y:= Y1 to Y2 do
  Mem[virseg:Y*320+X]:=C;
 End;

 Procedure OuttextXY(x,y:word; txt:string; C,lvseg:word);
 Var i,j,k:byte;
 Begin
  for i:=1 to length(txt) do for j:=0 to 7 do for k:=0 to 7 do
    if ((mem[fseg:fofs+ord(txt[i])*8+j] shl k) and 128) <> 0 then
      mem[lvseg:(y+j)*320+(i*8)+x+k]:=C;
 End;

 Procedure ClearDevice;
 Var i,i2:word;
 Begin
  For i:= 0 to 320 do For i2:= 0 to 200 do Mem[virseg:i2*320+i]:=0;
 End;


 Function I2S(L:LongInt):String;
  {Converts an integer to a string for use with OutText, OutTextXY }
 Var
  S:String;
 Begin
  Str(L, S);
  I2S:= S;
 End; { I2S }

 Procedure LoadPalette(FileName:String);
 Var
  i:Integer;
  R,G,B:Byte;
 Begin
  Assign(BFile,FileName);
  Reset(BFile);
  For i:= 0 to 255 do begin
   R:=63;
   G:=63;
   B:=63;
   Read(BFile,R);
   Read(BFile,G);
   Read(BFile,B);
   MakeColor(i,R,G,B);
  End;
  Close(BFile);
 End;

 Procedure CopyTiles;
 Var
  X,Y:Integer;
  Size:Word;
  FileName:String;
  PX1,PX2,PY1,PY2,o,i,i2,i3,i4,Mi:Integer;
 Begin
  For Mi:= 1 to MaxRTypes do begin
   Case Mi of
    1: FileName:='Road1.dpc';
    2: FileName:='Road2.dpc';
    3: FileName:='Road3.dpc';
    4: FileName:='Road4.dpc';
    Else FileName:='Road1.dpc';
   End;
   Assign(PicFile,FileName);
    Reset(PicFile);
    o:= 0;
    Read(PicFile,X);
    Read(PicFile,Y);
    With R[Mi] do begin
     GetMem(buf,RXSize*RYSize);
     Sprseg:=seg(buf^);
     For i4:= 0 to RYSize-1 do
     For i2:= 0 to RXSize-1 do begin
      Read(PicFile,o);
      Mem[Sprseg:i4*RXSize+i2]:=o;
     End;
    Close(PicFile);
   End;
  End;
  NoSound;

  For Mi:= 1 to MaxCTypes do begin                             { The rest are the floor tiles }
   Case Mi of
    1: FileName:='Semi1.dpc';
    2: FileName:='ECar1.dpc';
    3: FileName:='ETruck1.dpc';
    4: FileName:='RoadKil2.dpc';
    5: FileName:='RoadKill.dpc';
    Else Filename:= 'ECar1.dpc';
   End;
   Assign(PicFile,FileName);
    Reset(PicFile);
    o:= 0;
    Read(PicFile,X);
    Read(PicFile,Y);
    With C[Mi] do begin
     GetMem(buf,OXSize*OYSize);
     Sprseg:=seg(buf^);
     For i4:= 0 to OYSize-1 do
     For i2:= 0 to OXSize-1 do begin
      Read(PicFile,o);
      Mem[Sprseg:i4*OXSize+i2]:=o;
     End;
    Close(PicFile);
   End;
  End; { Loop Mi }

  For Mi:= 1 to MaxPlayers do begin                             { The rest are the floor tiles }
   Case Mi of
    1: FileName:='Car1b.dpc';
    2: FileName:='Truck1.dpc';
    3: FileName:='Tank1.dpc';
    4: FileName:='GlenCar.dpc';
    5: FileName:='DadCar.dpc';
    6: FileName:='Car1bh1.dpc';
    7: FileName:='Truck1h1.dpc';
    8: FileName:='Tank1h1.dpc';
    9: FileName:='GlenCar2.dpc';
    10: FileName:='DadCar2.dpc';
    Else Filename:= 'Car1b.dpc';
   End;
   Assign(PicFile,FileName);
    Reset(PicFile);
    o:= 0;
    Read(PicFile,X);
    Read(PicFile,Y);
    With P[Mi] do begin
     GetMem(buf,OXSize*OYSize);
     Sprseg:=seg(buf^);
     For i4:= 0 to OYSize-1 do
     For i2:= 0 to OXSize-1 do begin
      Read(PicFile,o);
      Mem[Sprseg:i4*OXSize+i2]:=o;
     End;
    Close(PicFile);
   End;
  End; { Loop Mi }

  For Mi:= 1 to MaxBTypes do begin                             { The rest are the floor tiles }
   Case Mi of
    1: FileName:='Bullet1.dpc';
    2: FileName:='Bullet2.dpc';
    3: FileName:='Bullet3.dpc';
    4: FileName:='Bullet4.dpc';
    5: FileName:='Bullet5.dpc';
    Else Filename:= 'Bullet1.dpc';
   End;
   Assign(PicFile,FileName);
    Reset(PicFile);
    o:= 0;
    Read(PicFile,X);
    Read(PicFile,Y);
    With B[Mi] do begin
     GetMem(buf,OXSize*OYSize);
     Sprseg:=seg(buf^);
     For i4:= 0 to OYSize-1 do
     For i2:= 0 to OXSize-1 do begin
      Read(PicFile,o);
      Mem[Sprseg:i4*OXSize+i2]:=o;
     End;
    Close(PicFile);
   End;
  End; { Loop Mi }
 End; {CopyTiles}

 Procedure PlaceLoad(X,Y:Integer;FileName:String;Place:Word);
 Var PX1,PX2,PY1,PY2,i,i2,i3,i4,o:Integer;
 Begin
  Assign(PicFile,FileName);
  Reset(PicFile);
  o:= 0;
  PX1:=X;
  PY1:=Y;
  Read(PicFile,X);
  PX2:= PX1+X;
  Read(PicFile,Y);
  PY2:= PY1+Y;
  For i4:= PY1 to PY2 do
  For i2:= PX1 to PX2 do begin
   Read(PicFile,o);
   If o=0 then o:=1
   Else Mem[virseg:i4*320+i2]:=o;
  End;
  Close(PicFile);
 End;

 Procedure StatusBar;
 Var i,i2,i3:Integer;
 Begin
  If Speed>MaxSpeed then Speed:=MaxSpeed;
  If Speed<0 then Speed:=0;
  For i:= 2 to 15 do Line(9+i*2,186,9+i*2,189,0,virseg);
  For i:= 1 to Speed do Line(9+i*2,186,9+i*2,189,Green-15+i,virseg);
  If GAS>MaxGas then GAS:=MaxGas;
  If GAS<0 then GAS:=0;
  For i:= 2 to 10 do Line(63+i*2,186,63+i*2,189,0,virseg);
  For i:= 1 to GAS do Line(63+i*2,186,63+i*2,189,Yellow-10+i,virseg);
  If Life>MaxLife then Life:=MaxLife;
  If Life<0 then Life:=0;
  For i:= 2 to 10 do Line(103+i*2,186,103+i*2,189,0,virseg);
  For i:= 1 to Life do Line(103+i*2,186,103+i*2,189,Orange-10+i,virseg);
  OuttextXY((271-(Length('')*8)),184,'',0,virseg);
  OuttextXY((271-(Length(I2S(Score))*8)),184,I2S(Score),Red,virseg);
  {For i:= 1 to Tanks do begin
  PlaceLoad(121+i*10,181,'GAS.dpc',virseg);
  End;}
 End;

 Procedure Exit;
 Begin
  Music.Fade;
  Delay (3000);
  Music.Done;
  Release(heap);
  FreeMem(virscr,320*200);
  Textmode(lastmode);
  Halt;
 End;

 Procedure ChooseCar;
 Var ACol,ARow:Integer;
 Begin
  PutObject(88,80,P[1].sprseg,virseg);
  PutObject(148,80,P[2].sprseg,virseg);
  PutObject(208,80,P[3].sprseg,virseg);
  i:=235;
  i2:=255;
  i3:=1;
  ACol:=90;
  ARow:=110;
  Repeat
   Flip(virseg,vidseg,0);
   i:=i+1;
   i2:=i2+i3;
   If i>245 then i:=215;
   If (i2>89)or(i2<77) then i3:=i3*-1;
   OuttextXY(45,60,' Please select your Coffin',i,virseg);
   OuttextXY(ACol-3,ARow,'',i,virseg);
   If i2<>256 then begin
    OuttextXY(ACol-18,120,'Stats',i2+15,virseg);
    OuttextXY(ACol-50,128,'Price: $'+(I2S(CarPrice)),i2,virseg);
    OuttextXY(ACol-33,136,'Speed:'+(I2S(MaxSpeed*10)),i2-15,virseg);
    OuttextXY(ACol-37,144,'Mi/Gal:'+(I2S(GasGuzzle)),i2-30,virseg);
    OuttextXY(ACol-37,152,'Strength:'+I2S(Strength),i2-45,virseg);
   End;
   If i2=256 then i2:=78;
   Delay(20);
   Key:='~';
   If Keypressed then Key:=ReadKey;
   If Key=chr(0) then begin
    OuttextXY(ACol-3,ARow,'',0,virseg);
    OuttextXY(ACol-18,120,'Stats',0,virseg);
    OuttextXY(ACol-50,128,'Price: $'+(I2S(CarPrice)),0,virseg);
    OuttextXY(ACol-33,136,'Speed:'+(I2S(MaxSpeed*10)),0,virseg);
    OuttextXY(ACol-37,144,'Mi/Gal:'+(I2S(GasGuzzle)),0,virseg);
    OuttextXY(ACol-37,152,'Strength:'+I2S(Strength),0,virseg);

    Key:=ReadKey;
    If (ACol>90)and(Key='K') then ACol:=ACol-60;
    If (ACol<210)and(Key='M') then ACol:=ACol+60;
   End;
   If ACol=90 then CarType:=1;
   If ACol=150 then CarType:=2;
   If ACol=210 then CarType:=3;
   If CarType=1 then begin
    MaxSpeed:=15;
    Speed:=10;
    CarPrice:=25000;
    MaxGAS:=10;
    GAS:=10;
    MaxLife:=10;
    Life:=8;
    Strength:=5;
    CarFileName:='Car1b.dpc';
    GasGuzzle:=200;
    Bullets:=100;
    BFileName:='Bullet1.dpc';
    Weapon:=1;
    End;

   If CarType=2 then begin
    MaxSpeed:=12;
    Speed:=9;
    CarPrice:=30000;
    MaxGAS:=10;
    GAS:=10;
    MaxLife:=10;
    Life:=10;
    Strength:=8;
    CarFileName:='Truck1.dpc';
    GasGuzzle:=150;
    Bullets:=100;
    Weapon:=2;
   End;

   If CarType=3 then begin
    MaxSpeed:=10;
    Speed:=8;
    CarPrice:=40000;
    MaxGAS:=10;
    GAS:=10;
    MaxLife:=10;
    Life:=10;
    Strength:=10;
    CarFileName:='Tank1.dpc';
    GasGuzzle:=100;
    Bullets:=-1;
    Weapon:=3;
   End;

   If Key='G' then begin
    Bullets:=-1;
    CarType:=4;
    MaxSpeed:=12;
    CarFileName:='GlenCar.dpc';
    GasGuzzle:=70;
    Strength:=9;
    Weapon:=5;
    Key:=chr(13);
   End;

   If Key='D' then begin
    Bullets:=-1;
    CarType:=5;
    MaxSpeed:=15;
    CarFileName:='DadCar.dpc';
    GasGuzzle:=60;
    Strength:=8;
    Weapon:=4;
    Key:=chr(13);
   End;

   If Key=chr(27) then Exit;
  Until Key=chr(13);
 End;

 Procedure DrawPlayer(Col,Row:Integer);
 Begin
  PutObject(Col,Row,P[Cartype].sprseg,virseg);
 End;

 Procedure DrawRoad(Var RoadPos:LongInt);
 Var i:Integer;
 Begin
 For i:= RoadPos to RoadPos+17 do
  PutRoad(110,(i-RoadPos-1)*10+5,R[RoadMap[i]].sprseg,virseg);
 RoadPos:=RoadPos-1;
 End;

 Procedure Die;
 Var X,Y,i,o:Integer;
 Begin
 { For i:= 1 to 10 do begin
   (30-i*3);
   Rectangle(50+i,40+i,280-i,110-i);
  End;}
  For i:= 60 to 270 do For i2:= 50 to 100 do Line(i,i2,i,i2,0,vidseg);
  OutTextXY(64,64,'     You Have Died      ',White,vidseg);
  OutTextXY(64,72,' Want to Exit? (Y or N) ',White,vidseg);
  While not KeyPressed do;
  Key:=ReadKey;
  If UpCase(Key)='Y' then begin
  Exit;
  End;
  Key:='~';                                                  { Something funky for display to go through }
  RefreshStats:=True;
  ClearDevice;
 End;


 BEGIN
  Asm mov ax,13h; int 10h; end;
  GetMem(virscr,320*200);
  virseg:=seg(virscr^);
  cls(virseg);
  GetMem(bgscr,320*200);
  bgseg:=seg(bgscr^);
  cls(bgseg);
  Mark(heap);
  LoadPalette('game.pal');
  GetFont;
  CopyTiles;
  Sounds:=True;

  For i:=1 to MaxRoadSize do begin
   i2:=Random(20)+1;
   If i2>4 then i2:=Random(2)+1;
   RoadMap[i]:=i2;
  End;

  FinishRow:=MaxRoadSize-1000;
  Level:=1;

  Relevel:
  ChooseCar;

  Case Weapon of
   1:Begin
      BSpeed:=11;
      BlastFileName:='Blast1.dpc';
      BFileName:='Bullet1.dpc';
      BulletAttack:=1;
     End;
   2:Begin
      BSpeed:=12;
      BlastFileName:='Blast2.dpc';
      BFileName:='Bullet2.dpc';
      BulletAttack:=2;
     End;
   3:Begin
      BSpeed:=13;
      BFileName:='Bullet3.dpc';
      BlastFileName:='Blast3.dpc';
      BulletAttack:=5;
     End;
   4:Begin
      BSpeed:=20;
      BFileName:='Bullet4.dpc';
      BlastFileName:='Blast1.dpc';
      BulletAttack:=5;
     End;
   5:Begin
      BSpeed:=17;
      BFileName:='Bullet5.dpc';
      BlastFileName:='Blast2.dpc';
      BulletAttack:=5;
     End;
  End;
  Tanks:=2;

  ClearDevice;
  OuttextXY(50,70,'Level 1: Texas Interstate',Level*15-1,virseg);
  Flip(virseg,vidseg,0);
  Delay(2000);
  If Level=1 then begin
   For i:=1 to 10 do Car[i].Kin:=1;
   For i:=11 to 20 do Car[i].Kin:=2;
   For i:=21 to 30 do Car[i].Kin:=3;
   For i:=31 to 40 do Car[i].Kin:=4;
   For i:=41 to MaxCars do Car[i].Kin:=5;
  End;
  RKS:=4;

  For i:=1 to MaxCars do begin
   With Car[i] do begin
    If Kin>0 then begin
     If Kin=1 then begin
      Col:=120;
      Row:=(-((Random(FinishRow)+1)*10));
      Attack:=8;
      Speed:=8;
     End;
     If Kin=2 then begin
      Col:=120+Random(4)*10;
      Row:=(-((Random(FinishRow)+1)*10));
      Attack:=7;
      Speed:=6;
     End;
     If Kin=3 then begin
      Col:=120+Random(2)*10;
      Row:=(-((Random(FinishRow)+1)*10));
      Attack:=8;
      Speed:=5;
     End;
     If Kin=4 then begin
      Col:=160+Random(4)*10;
      Row:=(-((Random(FinishRow)+1)*10));
      Attack:=5;
      Speed:=0;
     End;
     If Kin=5 then begin
      Col:=160+Random(4)*10;
      Row:=(-((Random(FinishRow)+1)*10));
      Attack:=4;
      Speed:=0;
     End;
    End;
   End;
  End;

  Life:=MaxLife;
  CS:=Strength;

  PCol:=150;
  PRow:=140;
  RoadPos:=MaxRoadSize-20;
  ClearDevice;
  PlaceLoad(0,178,'Dashbar1.dpc',bgseg);
  PlaceLoad(158,178,'Dashbar2.dpc',bgseg);
  StatusBar;

  IF Music.LoadFile ('SMJOOP.HSC') then Music.Start;

  Repeat
   DrawRoad(RoadPos);
   Tracker:=Tracker+1;
   DrawPlayer(PCol,PRow-Speed);

   If Tracker mod GasGuzzle=0 then begin
    RefreshStats:=True;
    GAS:=GAS-1;
   End;
   If GAS=0 then begin
    If Sounds then begin
     Sound(Speed*20);
     Delay(100-Speed*2);
     NoSound;
    End;
    Speed:=Speed-1;
    RefreshStats:=True;
   End;
   If (Gas<=0) and (Speed<1) then Exit;

   For i:=1 to MaxCars do begin
    With Car[i] do begin
     If Kin>0 then begin
      Row:=Row+10;
      If (Row>=150) and (Kin>0) then begin
       Kin:=0;
       Score:=Score+25+Kin*10;
       RefreshStats:=True;
      End;
      If (Row>0) and (Row<150) then begin
       If Kin<RKS then Col:=Col+Random(5)-2;
       PutObject(Col,Row,C[Kin].sprseg,virseg);
       Row:=Row+Random(Speed)+Speed;
       If (Sounds) and (Kin<RKS) then begin
        Sound(29+Random(2));
        Delay(20);
       End;
       If (PCol-15<Col)and(PCol+15>Col)and(PRow-32<Row)and(PRow-8>Row) then begin
        RefreshStats:=True;
        CS:=CS-Attack;
        If CS<0 then begin
         Life:=Life-1;
         CS:=Strength-CS-Attack;
        End;
        If CS=0 then begin
         Life:=Life-1;
         CS:=Strength;
        End;
        If Sounds then begin
         For i2:=1 to 10 do begin
          Sound(500-i2*50);
          Delay(10-i2);
          NoSound;
         End;
        End;
       End;
       If (Kin>1) and (Kin<RKS) then begin
        If Col<PCol then Col:=Col+Round(Random(Speed)/2);
        If Col>PCol then Col:=Col-Round(Random(Speed)/2);
       End;
      End;
     End;
    End;
   End;
   For i:= 1 to MaxBullets do begin
    BPos[i,2]:=BPos[i,2]-BSpeed;
    If BPos[i,2]>5 then begin
     PutObject(BPos[i,1],BPos[i,2],B[Weapon].sprseg,virseg);
     For i2:= 1 to MaxCars do begin
      If (BPos[i,1]>=Car[i2].Col-Round(OXSize/2))and(BPos[i,1]<=Car[i2].Col+Round(OXSize/2))and
      (BPos[i,2]>Car[i2].Row-BSpeed)and(BPos[i,2]<Car[i2].Row+BSpeed)and(Car[i2].Kin<>0) then begin
       Car[i2].CLife:=Car[i2].CLife-BulletAttack;
       If Car[i2].CLife<=0 then begin
        Car[i2].Kin:=0;
       End;
       Score:=Score+100;
       RefreshStats:=True;
       If Sounds then begin
        For i3:= 1 to 100 do begin
         Sound(i3*15);
         Delay(1-Round(i/100));
        End;
        For i3:= 1 to 100 do begin
         Sound(i3*10);
         Delay(1-Round(i/100));
        End;
        For i3:= 1 to 100 do begin
         Sound(i3*5);
         Delay(1-Round(i/100));
        End;
       End;
      End;
     End;
    End;
   End;
    For i2:=MaxBullets downto 2 do If BPos[i2,2]<5 then CBullet:=i2-1;

   If Key=' ' then begin
    If (Bullets<>0)and(CBullet<MaxBullets) then begin
     If Bullets<0 then Bullets:=-1;
     Bullets:=Bullets-1;
     CBullet:=CBullet+1;
     BPos[CBullet,1]:=PCol;
     BPos[CBullet,2]:=PRow-BSpeed;
     PlaceLoad(PCol+3,PRow-Speed-15,BlastFileName,virseg);
     If Sounds Then begin
      Sound(700);
      Delay(5);
      Sound(500);
      Delay(5);
      Sound(300);
      Delay(5);
      For i:=1 to 5 do begin
       Sound(100-i*20);
       Delay(5);
      End;
     End;
    End;
   End;

   Delay(300-Speed*20);
   NoSound;

   If Key<>'~' then begin
   End;
   Key:='~';
   If Keypressed then Key:=ReadKey;
   If Key=chr(0) then begin
    Key:=ReadKey;
    If (Key='H')and(GAS>0) then begin
     Speed:=Speed+1;
     RefreshStats:=True;
    End;
    If Key='P' then begin
     Speed:=Speed-1;
     RefreshStats:=True;
    End;
    If Key='K' then begin
     PCol:=PCol-2-Round((15-Speed)/10);
    End;
    If Key='M' then begin
     PCol:=PCol+2+Round((15-Speed)/10);
    End;
    If PCol>191 then PCol:=191;
    If PCol<109 then PCol:=109;
   End;

   If Key=chr(27) then Exit;
   If RefreshStats=True then begin
    RefreshStats:=False;
    StatusBar;
   End;
   If Life<Round(MaxLife/2) then begin
    Case Cartype of
    1: CarType:=6;
    2: CarType:=7;
    3: CarType:=8;
    4: CarType:=9;
    5: CarType:=10;
    End;
   End;
   If Life<=0 then Begin
    Die;
    Goto ReLevel;
   End;
   X:=5;
   Flip(virseg,vidseg,0);
  Until X=200;
  Exit;
 END.

